## lib3mf 1.0

=== Project/Lib3MFGCC/Makefile ===
#
# Installation target folder can be given using the INSTALL_ROOT variable.
# It defaults to /usr/local if not set on command line.
#
# Example:
#   make install INSTALL_ROOT=/opt
#
# This will install into /opt/include/lib3mf and /opt/lib
#
# Supported variables:
#   INSTALL_ROOT        Define the base folder for installation
#   INSTALL_BUILD_TYPE  Define which build to install Release or Debug
#                       (default is Release)
#   INSTALL_LIB_DIR     Define the name of the library folder, e.g for
#                       installation into 'lib64' (default is 'lib')
#

INSTALL_ROOT = /usr/local
INSTALL_FILE = install -m 644 -p
INSTALL_DIR  = cp -f -R

INSTALL_LIB_DIR = lib
INSTALL_BUILD_TYPE = Release

SYSTEM_NAME := $(shell uname -s)
SYSTEM_MAKEFILE := Makefile.$(SYSTEM_NAME)

ifneq ("$(wildcard $(SYSTEM_MAKEFILE))","")
  include $(SYSTEM_MAKEFILE)
else
  $(error Unsupported system: $(SYSTEM_NAME) - Could not find $(SYSTEM_MAKEFILE))
endif

.PHONY: install_headers
install_headers:
	@test -d $(INSTALL_ROOT)/include/lib3mf/ || mkdir -p $(INSTALL_ROOT)/include/lib3mf/
	-$(INSTALL_DIR) ../../Include/* $(INSTALL_ROOT)/include/lib3mf/

.PHONY: install_library
install_library:
	@test -d $(INSTALL_ROOT)/$(INSTALL_LIB_DIR)/ || mkdir -p $(INSTALL_ROOT)/$(INSTALL_LIB_DIR)/
	-$(INSTALL_FILE) bin/$(INSTALL_BUILD_TYPE)/lib3* $(INSTALL_ROOT)/$(INSTALL_LIB_DIR)/

.PHONY: install
install: install_headers install_library

## lib3mf 1.8.1%2Bds

=== UnitTests/CPP/CMakeLists.txt ===
#########################################################
# Unittests on internal classes of the library

SET(TESTNAME "UnitTestsCPP")

set(SRCS_UNITTEST
./Source/UnitTest_AllTests.cpp
./Source/UnitTest_Geometry.cpp
./Source/UnitTest_Mesh.cpp
./Source/UnitTest_MeshFormat_STL.cpp
./Source/UnitTest_Model.cpp
./Source/UnitTest_ModelFactory.cpp
./Source/UnitTest_ZIP.cpp
)

set(CMAKE_CURRENT_BINARY_DIR ${CMAKE_BINARY_DIR})
add_executable(${TESTNAME} ${SRCS_UNITTEST})

if (WIN32)
	target_compile_options(${TESTNAME} PUBLIC "$<$<CONFIG:DEBUG>:/Od;/Ob0;/Gm;/sdl;/W3;/WX;/FC;/MTd;/wd4996>")
	target_compile_options(${TESTNAME} PUBLIC "$<$<CONFIG:RELEASE>:/O2;/sdl;/WX;/Oi;/Gy;/FC;/MT;/wd4996>")
endif()

target_include_directories(${TESTNAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/Include ${gtest_SOURCE_DIR}/include)
target_link_libraries(${TESTNAME} ${PROJECT_NAME}_s gtest gtest_main)
add_dependencies(${TESTNAME} ${PROJECT_NAME}_s)
set_target_properties(${TESTNAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/")

add_test(${TESTNAME} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME})

=== UnitTests/C_Interface/CMakeLists.txt ===
#########################################################
# Tests on the C-interface of the library

SET(TESTNAME "Test_CInterface")

set(SRCS_UNITTEST
./Source/UnitTest_AllTests.cpp
./Source/UnitTest_Attachments.cpp
./Source/UnitTest_BeamLattice.cpp
./Source/UnitTest_Production.cpp
./Source/UnitTest_ProgressCallback.cpp
./Source/UnitTest_ReaderStrictMode.cpp
./Source/UnitTest_Extensions.cpp
./Source/UnitTest_OPC_Issues.cpp
./Source/UnitTest_ReadWrite.cpp
./Source/UnitTest_Slice.cpp
./Source/UnitTest_Textures.cpp
./Source/UnitTest_Thumbnails.cpp
)

set(CMAKE_CURRENT_BINARY_DIR ${CMAKE_BINARY_DIR})
add_executable(${TESTNAME} ${SRCS_UNITTEST})

if (WIN32)
	target_compile_options(${TESTNAME} PUBLIC "$<$<CONFIG:DEBUG>:/Od;/Ob0;/Gm;/sdl;/W3;/WX;/FC;/MTd;/wd4996>")
	target_compile_options(${TESTNAME} PUBLIC "$<$<CONFIG:RELEASE>:/O2;/sdl;/WX;/Oi;/Gy;/FC;/MT;/wd4996>")
endif()

target_include_directories(${TESTNAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/Include ${gtest_SOURCE_DIR}/include)
target_link_libraries(${TESTNAME} ${PROJECT_NAME} gtest gtest_main)
add_dependencies(${TESTNAME} ${PROJECT_NAME})
set_target_properties(${TESTNAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/")

add_test(${TESTNAME} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME})
set(STARTUPPROJECT ${TESTNAME} PARENT_SCOPE)

=== debian/control ===
Source: lib3mf
Section: libs
Priority: optional
Maintainer: Torsten Paul <Torsten.Paul@gmx.de>
Uploaders: Kristian Nielsen <knielsen@knielsen-hq.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>=12~), pkg-kde-tools, cmake, libzip-dev, zlib1g-dev, uuid-dev
Standards-Version: 4.3.0
Homepage: https://github.com/3MFConsortium/lib3mf

Package: lib3mf1t64
Provides: ${t64:Provides}
Replaces: lib3mf1
Breaks: lib3mf1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Lib3MF is a C++ implementation of the 3D Manufacturing Format
 As 3MF shall become an universal 3D Printing standard,
 its quick adoption is very important. This library shall
 lower all barriers of adoption to any possible user, let
 it be software providers, hardware providers, service
 providers or middleware tools. The specification can be
 downloaded at http://3mf.io/specification/
 .
 Its aim is to offer an open source way to integrate 3MF
 reading and writing capabilities, as well as conversion
 and validation tools for input and output data. The 3MF
 Library shall provide a clean and easy-to-use API to speed
 up the development and keep integration costs at a minimum.

Package: lib3mf-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Lib3MF is a C++ implementation of the 3D Manufacturing Format (documentation)
 As 3MF shall become an universal 3D Printing standard,
 its quick adoption is very important. This library shall
 lower all barriers of adoption to any possible user, let
 it be software providers, hardware providers, service
 providers or middleware tools. The specification can be
 downloaded at http://3mf.io/specification/
 .
 Its aim is to offer an open source way to integrate 3MF
 reading and writing capabilities, as well as conversion
 and validation tools for input and output data. The 3MF
 Library shall provide a clean and easy-to-use API to speed
 up the development and keep integration costs at a minimum.
 .
 This package contains the documentation files.

Package: lib3mf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: lib3mf1t64 (= ${binary:Version}), ${misc:Depends}
Description: Lib3MF is a C++ implementation of the 3D Manufacturing Format (development)
 As 3MF shall become an universal 3D Printing standard,
 its quick adoption is very important. This library shall
 lower all barriers of adoption to any possible user, let
 it be software providers, hardware providers, service
 providers or middleware tools. The specification can be
 downloaded at http://3mf.io/specification/
 .
 Its aim is to offer an open source way to integrate 3MF
 reading and writing capabilities, as well as conversion
 and validation tools for input and output data. The 3MF
 Library shall provide a clean and easy-to-use API to speed
 up the development and keep integration costs at a minimum.
 .
 This package contains the development files.

## lib3mf 1.8.1+ds

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.2)

IF (NOT ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} LESS 3.1)
  cmake_policy(SET CMP0054 OLD)
ENDIF ()

# Define Project and Version Numbers
# increase major version on every backward-compatibility breaking change of the API
# increase minor version on every backward compatible change of the API
# increase patch version on every change that does not alter the API
project (lib3MF
	VERSION 1.8.1
	DESCRIPTION "Lib3MF is a C++ implementation of the 3D Manufacturing Format file standard.")

include(GNUInstallDirs)

# By default no COM interface is built
# use the cmake option -DNMR_COM_NATIVE:BOOL=ON to build the COM interface
option(NMR_COM_NATIVE "Implement a COM interface" OFF)

option(USE_INCLUDED_ZLIB "Use included zlib" ON)
option(USE_INCLUDED_LIBZIP "Use included libzip" ON)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  # using GCC
  add_definitions(-DBUILD_DLL)
  add_compile_options(-Wall)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -O2")
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  # using GCC
  add_definitions(-DBUILD_DLL)
  add_compile_options(-Wall) 
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -O2")
  set(CMAKE_MACOSX_RPATH ON)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  # using Visual Studio C++
  add_definitions(-DBUILD_DLL -DLIB3MF_EXPORTS /W3)
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} xmllite.lib")
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS)
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
  if(NMR_COM_NATIVE)
	add_definitions(-DNMR_COM_NATIVE)
  endif()
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Include/Model/COM/NMR_COMVersion.h.in" "${CMAKE_CURRENT_BINARY_DIR}/Include/Model/COM/NMR_COMVersion.h")

include(Source/CMakeLists.txt)

if (WIN32)
	SET(SRCS_MAIN_PLATFORM
	"${SRCS_WIN_MAIN}"
	)
else()
	# Linux and MAC
	SET(SRCS_MAIN_PLATFORM
	"${SRCS_UNIX_MAIN}"
	)
endif()


#########################################################
# Set version info
if(DEFINED ENV{BUILD_NUMBER})
	set(BUILD_NUMBER $ENV{BUILD_NUMBER})
else()
	set(BUILD_NUMBER 0)
endif()

if (WIN32)
	message("BUILD_NUMBER ... " ${BUILD_NUMBER})
	set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/Release/VersionInfo)
	
	include(generate_product_version)
	generate_product_version(
	   VERSION_FILES_OUTPUTLOCATION
	   NAME "lib3MF"
	   FILE_DESCRIPTION "Lib3MF is the reference-implementation of the 3D Manufacturing Format file standard"
	   BUNDLE "3MF Consortium"
	   VERSION_MAJOR ${PROJECT_VERSION_MAJOR}
	   VERSION_MINOR ${PROJECT_VERSION_MINOR}
	   VERSION_PATCH ${PROJECT_VERSION_PATCH}
	   VERSION_REVISION ${BUILD_NUMBER}
	   PRODUCT_VERSION_MAJOR ${PROJECT_VERSION_MAJOR}
	   PRODUCT_VERSION_MINOR ${PROJECT_VERSION_MINOR}
	   PRODUCT_VERSION_PATCH ${PROJECT_VERSION_PATCH}
	   COMPANY_NAME "3MF Consortium"
	)
	message("VERSION_FILES_OUTPUTLOCATION ... " ${VERSION_FILES_OUTPUTLOCATION})
else()
	set(VERSION_FILES_OUTPUTLOCATION "")
endif()


#########################################################
# Static library (as base for other targets)
add_library(${PROJECT_NAME}_s STATIC ${SRCS_MAIN_PLATFORM} ${SRCS_COMMON})
target_include_directories(${PROJECT_NAME}_s PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/Include)
target_include_directories(${PROJECT_NAME}_s PUBLIC ${CMAKE_CURRENT_BINARY_DIR}/Include)
SET_TARGET_PROPERTIES(${PROJECT_NAME}_s PROPERTIES PREFIX "" IMPORT_PREFIX "")
if (UNIX OR MINGW)
	target_compile_options(${PROJECT_NAME}_s PUBLIC "-fPIC")
	# Uncomment the following to but the version info into the .so-file.
	SET_TARGET_PROPERTIES(${PROJECT_NAME}_s PROPERTIES VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
	SET_TARGET_PROPERTIES(${PROJECT_NAME}_s PROPERTIES SOVERSION "${PROJECT_VERSION_MAJOR}")
	if (NOT APPLE)
		SET_TARGET_PROPERTIES(${PROJECT_NAME}_s PROPERTIES LINK_FLAGS -s)
	endif()
	if (NOT WIN32)
		find_library(LIBUUID_PATH uuid)
		if(NOT LIBUUID_PATH)
			message(FATAL_ERROR "libuuid not found")
		endif()
		target_link_libraries(${PROJECT_NAME}_s ${LIBUUID_PATH})
	endif()
else()
	# wd4996 masks the deprecated-warning
	target_compile_options(${PROJECT_NAME}_s PUBLIC "$<$<CONFIG:DEBUG>:/Od;/Ob0;/Gm;/sdl;/W3;/WX;/FC;/wd4996>")
	target_compile_options(${PROJECT_NAME}_s PUBLIC "$<$<CONFIG:RELEASE>:/O2;/sdl;/WX;/Oi;/Gy;/FC;/wd4996>")
endif()


#########################################################
# Shared library
add_library(${PROJECT_NAME} SHARED ${SRCS_MAIN_PLATFORM}
	"./Source/Model/COM/NMR_DLLInterfaces.cpp"
	${VERSION_FILES_OUTPUTLOCATION}
)
set(STARTUPPROJECT ${PROJECT_NAME})
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES PREFIX "" IMPORT_PREFIX "")
target_link_libraries(${PROJECT_NAME} ${PROJECT_NAME}_s)
if (UNIX OR MINGW)
	# Uncomment the following to but the version info into the .so-file.
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.${BUILD_NUMBER}")
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES SOVERSION "${PROJECT_VERSION_MAJOR}")
endif()
install(TARGETS ${PROJECT_NAME}
	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
install(DIRECTORY Include/Model DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(DIRECTORY Include/Common DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Include/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

#########################################################
configure_file(lib3MF.pc.in lib3MF.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/lib3MF.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

#########################################################
option(LIB3MF_TESTS "Switch whether the tests of Lib3MF should be build" ON)
if(NOT DEFINED LIB3MF_TESTS)
	set(LIB3MF_TESTS TRUE)
endif()
message("LIB3MF_TESTS ... " ${LIB3MF_TESTS})
if(LIB3MF_TESTS)
	include(CTest)
	add_subdirectory(UnitTests)
endif()


if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
	IF(${CMAKE_VERSION} VERSION_LESS 3.6.3)
		MESSAGE ("Note: You need to manually select a StartUp-project in Visual Studio.")
	ELSE()
		set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT ${STARTUPPROJECT})
	ENDIF()
endif()

=== Source/CMakeLists.txt ===
if (USE_INCLUDED_LIBZIP)
	file(GLOB LIBZIP_FILES ./Source/Libraries/libzip/*.c)
endif()

if (USE_INCLUDED_ZLIB)
	file(GLOB ZLIB_FILES ./Source/Libraries/zlib/*.c)
endif()

if(NMR_COM_NATIVE)
	# sources for native COM implementation
	set(SRCS_COM
	${LIBZIP_FILES}
	./Source/Common/Platform/NMR_Platform_COM.cpp
	./Source/Common/Platform/NMR_ExportStream_COM.cpp
	./Source/Common/Platform/NMR_ImportStream_COM.cpp
	)
else()
	# sources for COM emulation
	set(SRCS_COM
	${LIBZIP_FILES}
	./Source/Model/COM/NMR_COMInterface_GCC.cpp
	./Source/Common/Platform/NMR_Platform_GCC.cpp
	./Source/Common/Platform/NMR_ImportStream_GCC_Native.cpp
	./Source/Common/Platform/NMR_ImportStream_GCC_Win32.cpp
	./Source/Common/Platform/NMR_ExportStream_GCC_Native.cpp
	./Source/Common/Platform/NMR_ExportStream_GCC_Win32.cpp
	./Source/Common/Platform/NMR_ExportStream_ZIP.cpp
	)
endif()

set(SRCS_WIN_MAIN
./Source/Main/dllmain.cpp
)

set(SRCS_UNIX_MAIN
./Source/Main/main.cpp
)


set(SRCS_COMMON
${SRCS_COM}
./Source/Common/3MF_ProgressMonitor.cpp
./Source/Model/Reader/NMR_ModelReader_InstructionElement.cpp
./Source/Common/Math/NMR_Matrix.cpp
./Source/Common/Math/NMR_PairMatchingTree.cpp
./Source/Common/Math/NMR_Vector.cpp
./Source/Common/Math/NMR_VectorTree.cpp
./Source/Common/MeshExport/NMR_MeshExporter.cpp
./Source/Common/MeshExport/NMR_MeshExporter_STL.cpp
./Source/Common/MeshImport/NMR_MeshImporter.cpp
./Source/Common/MeshImport/NMR_MeshImporter_STL.cpp
./Source/Common/MeshInformation/NMR_MeshInformation.cpp
./Source/Common/MeshInformation/NMR_MeshInformationContainer.cpp
./Source/Common/MeshInformation/NMR_MeshInformationFactory.cpp
./Source/Common/MeshInformation/NMR_MeshInformationHandler.cpp
./Source/Common/MeshInformation/NMR_MeshInformation_BaseMaterials.cpp
./Source/Common/MeshInformation/NMR_MeshInformation_NodeColors.cpp
./Source/Common/MeshInformation/NMR_MeshInformation_TexCoords.cpp
./Source/Common/Mesh/NMR_Mesh.cpp
./Source/Common/Mesh/NMR_BeamLattice.cpp
./Source/Common/Mesh/NMR_MeshBuilder.cpp
./Source/Common/NMR_Exception.cpp
./Source/Common/NMR_Exception_Windows.cpp
./Source/Common/NMR_StringUtils.cpp
./Source/Common/NMR_UUID.cpp
./Source/Common/OPC/NMR_OpcPackagePart.cpp
./Source/Common/OPC/NMR_OpcPackageRelationship.cpp
./Source/Common/OPC/NMR_OpcPackageReader.cpp
./Source/Common/OPC/NMR_OpcPackageContentTypesReader.cpp
./Source/Common/OPC/NMR_OpcPackageRelationshipReader.cpp
./Source/Common/OPC/NMR_OpcPackageWriter.cpp
./Source/Common/Platform/NMR_XmlReader_Native.cpp
./Source/Model/Reader/NMR_ModelReader_3MF_Native.cpp
./Source/Common/Platform/NMR_ExportStream.cpp
./Source/Common/Platform/NMR_ExportStream_Callback.cpp
./Source/Common/Platform/NMR_ExportStream_Memory.cpp
./Source/Common/Platform/NMR_ExportStream_Dummy.cpp
./Source/Common/Platform/NMR_ExportStream_ZIP.cpp
./Source/Common/Platform/NMR_ImportStream_Callback.cpp
./Source/Common/Platform/NMR_ImportStream_Memory.cpp
./Source/Common/Platform/NMR_ImportStream_ZIP.cpp
./Source/Common/Platform/NMR_PortableZIPWriter.cpp
./Source/Common/Platform/NMR_PortableZIPWriterEntry.cpp
./Source/Common/Platform/NMR_Time.cpp
./Source/Common/Platform/NMR_XmlReader.cpp
./Source/Common/Platform/NMR_XmlWriter.cpp
./Source/Common/Platform/NMR_XmlWriter_Native.cpp
${ZLIB_FILES}
./Source/Model/Classes/NMR_PackageResourceID.cpp
./Source/Model/Classes/NMR_Model.cpp
./Source/Model/Classes/NMR_ModelAttachment.cpp
./Source/Model/Classes/NMR_ModelBaseMaterial.cpp
./Source/Model/Classes/NMR_ModelBaseMaterials.cpp
./Source/Model/Classes/NMR_ModelBuildItem.cpp
./Source/Model/Classes/NMR_ModelComponent.cpp
./Source/Model/Classes/NMR_ModelComponentsObject.cpp
./Source/Model/Classes/NMR_ModelDefaultProperty.cpp
./Source/Model/Classes/NMR_ModelDefaultProperty_BaseMaterial.cpp
./Source/Model/Classes/NMR_ModelDefaultProperty_Color.cpp
./Source/Model/Classes/NMR_ModelDefaultProperty_TexCoord2D.cpp
./Source/Model/Classes/NMR_ModelMeshBeamLatticeAttributes.cpp
./Source/Model/Classes/NMR_ModelMeshObject.cpp
./Source/Model/Classes/NMR_ModelMetaData.cpp
./Source/Model/Classes/NMR_ModelObject.cpp
./Source/Model/Classes/NMR_ModelResource.cpp
./Source/Model/Classes/NMR_ModelTexture2D.cpp
./Source/Model/Classes/NMR_ModelSliceStackResource.cpp
./Source/Model/COM/NMR_COMInterface_Model.cpp
./Source/Model/COM/NMR_COMInterface_ModelAttachment.cpp
./Source/Model/COM/NMR_COMInterface_ModelBaseMaterial.cpp
./Source/Model/COM/NMR_COMInterface_ModelBuildItem.cpp
./Source/Model/COM/NMR_COMInterface_ModelBuildItemIterator.cpp
./Source/Model/COM/NMR_COMInterface_ModelComponent.cpp
./Source/Model/COM/NMR_COMInterface_ModelComponentsObject.cpp
./Source/Model/COM/NMR_COMInterface_ModelDefaultPropertyHandler.cpp
./Source/Model/COM/NMR_COMInterface_ModelFactory.cpp
./Source/Model/COM/NMR_COMInterface_ModelMeshObject.cpp
./Source/Model/COM/NMR_COMInterface_ModelMeshBeamSet.cpp
./Source/Model/COM/NMR_COMInterface_ModelPropertyHandler.cpp
./Source/Model/COM/NMR_COMInterface_ModelReader.cpp
./Source/Model/COM/NMR_COMInterface_ModelResourceFactory.cpp
./Source/Model/COM/NMR_COMInterface_ModelResourceIterator.cpp
./Source/Model/COM/NMR_COMInterface_ModelTexture2D.cpp
./Source/Model/COM/NMR_COMInterface_ModelWriter.cpp
./Source/Model/COM/NMR_COMInterface_Slice.cpp
./Source/Model/COM/NMR_DLLInterfaces.cpp
./Source/Model/Reader/BeamLattice1702/NMR_ModelReaderNode_BeamLattice1702_Beam.cpp
./Source/Model/Reader/BeamLattice1702/NMR_ModelReaderNode_BeamLattice1702_Beams.cpp
./Source/Model/Reader/BeamLattice1702/NMR_ModelReaderNode_BeamLattice1702_BeamLattice.cpp
./Source/Model/Reader/BeamLattice1702/NMR_ModelReaderNode_BeamLattice1702_BeamSet.cpp
./Source/Model/Reader/BeamLattice1702/NMR_ModelReaderNode_BeamLattice1702_BeamSets.cpp
./Source/Model/Reader/BeamLattice1702/NMR_ModelReaderNode_BeamLattice1702_Ref.cpp
./Source/Model/Reader/NMR_ModelReader.cpp
./Source/Model/Reader/NMR_ModelReaderNode.cpp
./Source/Model/Reader/NMR_ModelReaderNode_Model.cpp
./Source/Model/Reader/NMR_ModelReaderWarnings.cpp
./Source/Model/Reader/NMR_ModelReader_3MF.cpp
./Source/Model/Reader/NMR_ModelReader_ColorMapping.cpp
./Source/Model/Reader/NMR_ModelReader_STL.cpp
./Source/Model/Reader/NMR_ModelReader_TexCoordMapping.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Build.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_BuildItem.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Color.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Component.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Components.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Material.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Mesh.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Object.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Resources.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Texture.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_TextureVertex.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_TextureVertices.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Triangle.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Triangles.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Vertex.cpp
./Source/Model/Reader/v093/NMR_ModelReaderNode093_Vertices.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_BaseMaterial.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_BaseMaterials.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Build.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_BuildItem.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Color.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Colors.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Component.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Components.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Mesh.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_MetaData.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Object.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Resources.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Tex2Coord.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Tex2DGroup.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Texture2D.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Triangle.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Triangles.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Vertex.cpp
./Source/Model/Reader/v100/NMR_ModelReaderNode100_Vertices.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_Polygon.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_Segment.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_Slice.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_SliceRef.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_SliceRefModel.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_SliceRefResources.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_SliceStack.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_Vertex.cpp
./Source/Model/Reader/Slice1507/NMR_ModelReader_Slice1507_Vertices.cpp
./Source/Model/Writer/NMR_ModelWriter.cpp
./Source/Model/Writer/NMR_ModelWriterNode.cpp
./Source/Model/Writer/NMR_ModelWriter_3MF.cpp
./Source/Model/Writer/NMR_ModelWriter_3MF_Native.cpp
./Source/Model/Writer/NMR_ModelWriter_ColorMapping.cpp
./Source/Model/Writer/NMR_ModelWriter_STL.cpp
./Source/Model/Writer/NMR_ModelWriter_TexCoordMapping.cpp
./Source/Model/Writer/NMR_ModelWriter_TexCoordMappingContainer.cpp
./Source/Model/Writer/v100/NMR_ModelWriterNode100_Mesh.cpp
./Source/Model/Writer/v100/NMR_ModelWriterNode100_Model.cpp
)

=== UnitTests/CMakeLists.txt ===
ADD_SUBDIRECTORY (googletest EXCLUDE_FROM_ALL)
enable_testing()
	
SET(gtest_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/googletest/googletest")
add_definitions( -DTESTFILESPATH="${CMAKE_CURRENT_SOURCE_DIR}/../TestFiles")
add_definitions( -DLTESTFILESPATH=L"${CMAKE_CURRENT_SOURCE_DIR}/../TestFiles")
add_definitions( -DLOUTFILESPATH=L"${CMAKE_BINARY_DIR}/")

# Tests on the C-interface of the library
add_subdirectory(C_Interface)

# Tests on internal classes of the library
add_subdirectory(CPP)

set(STARTUPPROJECT ${STARTUPPROJECT} PARENT_SCOPE)

=== SDK/Examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (WIN32)
	set(LSUFFIX "dll")
	set(LSUFFIXOUT ".dll")
elseif(UNIX AND NOT APPLE)
	set(LSUFFIX "so")
	set(LSUFFIXOUT ".so.1")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -O2")
else()
	set(LSUFFIX "dylib")
	set(LSUFFIXOUT ".1.dylib")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -O2")
endif()

add_definitions ( -DTEXTURESPATH="${CMAKE_CURRENT_SOURCE_DIR}/Files/Textures/" )

project (Examples)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../Include)
link_directories(${CMAKE_CURRENT_SOURCE_DIR}/../Lib)

if (WIN32)
	link_libraries(lib3MF)
else()
	# Unix prefixes the name of the library with "lib" anyway
	link_libraries(3MF)
	if(APPLE)
		link_directories(${CMAKE_CURRENT_BINARY_DIR})
        endif()
endif()

function(CopySharedLibrary MyTarget)
	add_custom_command(TARGET ${MyTarget} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/../Lib/lib3MF.${LSUFFIX}" $<TARGET_FILE_DIR:${MyTarget}>/lib3MF${LSUFFIXOUT})
endfunction(CopySharedLibrary)

add_executable(Example_ColorCube Source/ColorCube.cpp)
CopySharedLibrary(Example_ColorCube)

add_executable(Example_Components Source/Components.cpp)
CopySharedLibrary(Example_Components)

add_executable(Example_Converter Source/Converter.cpp)
CopySharedLibrary(Example_Converter)

add_executable(Example_Cube Source/Cube.cpp)
CopySharedLibrary(Example_Cube)

add_executable(Example_ExtractInfo Source/ExtractInfo.cpp)
CopySharedLibrary(Example_ExtractInfo)

add_executable(Example_TextureCube Source/TextureCube.cpp)
CopySharedLibrary(Example_TextureCube)

add_executable(Example_Slice Source/Slice.cpp)
CopySharedLibrary(Example_Slice)

add_executable(Example_BeamLattice Source/BeamLattice.cpp)
CopySharedLibrary(Example_BeamLattice)

if (WIN32)
	IF(${CMAKE_VERSION} VERSION_LESS 3.6.3)
		MESSAGE ("Note: You need to manually select a StartUp-project in Visual Studio.")
	ELSE()
		set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT Example_Cube)
	ENDIF()
endif()

=== debian/changelog ===
lib3mf (1.8.1+ds-6) unstable; urgency=medium

  * Fix build with Cmake 4. Closes: 1113104

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Fri, 03 Oct 2025 20:17:03 +0200

lib3mf (1.8.1+ds-5) unstable; urgency=medium

  * Fix incompatibility with libzip >= 1.9.0.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Thu, 24 Oct 2024 22:18:23 +0200

lib3mf (1.8.1+ds-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062323

 -- Lukas Märdian <slyon@debian.org>  Thu, 29 Feb 2024 08:29:36 +0000

lib3mf (1.8.1+ds-4) unstable; urgency=medium

  * Fix use-after-free (CVE-2021-21772), backporting fix from v2.1.1
    (Closes: #985092)

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Thu, 01 Apr 2021 21:25:54 +0200

lib3mf (1.8.1+ds-3.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Joel Ray Holveck ]
  * Include the links to libzip and zlib in the .so file, so the
    dependency system can find them.
  * Remove symbol files; switch to shlibs instead.

  [ gregor herrmann ]
  * Sponsor NMU (closes: #957420).

 -- gregor herrmann <gregoa@debian.org>  Sun, 06 Dec 2020 02:27:21 +0100

lib3mf (1.8.1+ds-3) unstable; urgency=medium

  * Update symbol file for amd64 (Closes: #924841)

 -- Torsten Paul <Torsten.Paul@gmx.de>  Tue, 26 Mar 2019 01:08:07 +0100

lib3mf (1.8.1+ds-2) unstable; urgency=medium

  * Update symbol file for hurd, kfreebsd, powerpc and ppc64
  * Fix lintian warning symbols-file-missing-build-depends-package-field

 -- Torsten Paul <Torsten.Paul@gmx.de>  Sun, 20 Jan 2019 18:42:40 +0100

lib3mf (1.8.1+ds-1) unstable; urgency=medium

  * New upstream version 1.8.1
  * Drop all patches as all changes are included upstream now via
    https://github.com/3MFConsortium/lib3mf/pull/114
  * Add upstream NEWS from github release page
  * Add Files-Excluded for removed libzip and zlib source
  * Address more of the pedantic lintian warnings
  * Update symbol file using pkgkde-symbolshelper
  * Bump debhelper compatibility to version 12
  * Bump standards version to 4.3.0

 -- Torsten Paul <Torsten.Paul@gmx.de>  Sun, 13 Jan 2019 19:22:14 +0100

lib3mf (1.8.0+ds-1) unstable; urgency=low

  * Initial release. (Closes: #917649)

 -- Torsten Paul <Torsten.Paul@gmx.de>  Tue, 01 Jan 2019 15:47:11 +0100

=== debian/watch ===
version=3
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$// \
https://github.com/3MFConsortium/lib3mf/tags .*/v?(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))

## lib3mf 1.8.1.1+ds

=== debian/changelog ===
lib3mf (1.8.1.1+ds-3+deb10u1+dde) unstable; urgency=medium

  * update

 -- Torsten Paul <Torsten.Paul@gmx.de>  Tue, 06 Jul 2021 10:09:44 +0800

lib3mf (1.8.1.1+ds-3+deb10u1+dde) buster-security; urgency=medium

  * Non-maintainer upload.
  * Update version.

 -- wangpei <wangpei@uniontech.com>  Wed, 30 Jun 2021 14:40:23 +0800

lib3mf (1.8.1+ds-3+deb10u1) buster-security; urgency=high

  * Fix use-after-free (CVE-2021-21772), backporting fix from v2.1.1
    (Closes: #985092)

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Mon, 05 Apr 2021 12:55:40 +0200
